(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["FRED`"];

(* Exported symbols added here with SymbolName::usage *) 

FRED::usage="FRED[\!\(\*
StyleBox[\"seriesID\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"startDate\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"endDate\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] takes a series ID, or lists of several series ID, and returns the data time series. The currently supported FRED options are those listed here: http://api.stlouisfed.org/docs/fred/series_observations.html. Options should be entered as rules: FRED option entered as a string \[Rule] option value entered as a string. Start and end dates are the date range for the data entered as Mathematica date lists.";


Unprotect[FRED];

Begin["`Private`"];
(* Implementation of the package *)


Clear[FRED,makeQueryString,stringToNumber,dateRules];

(* the next two functions I've left in a private section -- that is why they are colored differently. If you want to use them for other purposes then add usage statement above where the FRED usage statement is and also Unprotect and Protect them. *)

makeQueryString[rules_List]:=Module[{tmp},
tmp=rules/.Rule[x_String,y_String]:>StringJoin@@List[x,"=",y];
StringJoin@@(ToLowerCase/@Riffle[tmp,"&"])
];

stringToNumber[x_String]:=ToExpression[StringReplace[x,","->""]];

dateRules={{y_,1,_,x__}->{y,1,31,x},{y_,2,_,x__}:>DatePlus[{y,3,1,x},{-1,"Day"}],{y_,3,_,x__}->{y,3,31,x},{y_,4,_,x__}->{y,4,30,x},{y_,5,_,x__}->{y,5,31,x},{y_,6,_,x__}->{y,6,30,x},{y_,7,_,x__}->{y,7,31,x},{y_,8,_,x__}->{y,8,31,x},{y_,9,_,x__}->{y,9,30,x},{y_,10,_,x__}->{y,10,31,x},{y_,11,_,x__}->{y,11,30,x},{y_,12,_,x__}->{y,12,31,x}};

(* main FRED function *)

SyntaxInformation[FRED]={"ArgumentsPattern"->{_,_,_,OptionsPattern[]}};

(* ideally you would include your API key here as well *)

Options[FRED]={"api_key"->"","limit"->"","offset"->"","sort_order"->"","realtime_start"->"","realtime_end"->"","units"->"","output_type"->"","file_type"->"xml","vintage_dates"->""};

FRED[series:(_String|_List),startDate_,endDate_,opts:OptionsPattern[]]:=Module[{today,options,start1,end1,queryString,fileType,extension,tmp},

today=DateString[DateList[],{"Year","-","Month","-","Day"}];

(* collect options *)
options={
"api_key"->OptionValue["api_key"],
"limit"->OptionValue["limit"],
"offset"->OptionValue["offset"],
"sort_order"->OptionValue["sort_order"],
"realtime_start"->OptionValue["realtime_start"],
"realtime_end"->OptionValue["realtime_end"],
"units"->OptionValue["units"],
"output_type"->OptionValue["output_type"],
"file_type"->OptionValue["file_type"],
"vintage_dates"->OptionValue["vintage_dates"]
};

(* figured I'd set default options to "" and only include non-"" in the query string 
options=DeleteCases[options,Rule[_,""]];*)

(* make date strings *)
start1=DateString[startDate,{"Year","-","Month","-","Day"}];
end1=DateString[endDate,{"Year","-","Month","-","Day"}];

(* make query string insert *)
queryString=makeQueryString[options];

(* determine second argument for Import *)
fileType=ToLowerCase@OptionValue["file_type"];
extension=Switch[fileType,"xml","XML","xls","*","txt","*"];

tmp=Import["http://api.stlouisfed.org/fred/series/observations?series_id="<>ToString[#]<>"&observation_start="<>start1<>"&observation_end="<>end1<>"&"<>queryString,extension]&/@Flatten[{series}];

Switch[fileType,
"xml",Cases[tmp,XMLElement["observation",{___,"date"->x_,"value"->y_},___]:>{DateList@x,stringToNumber@y},{1,4}],
"xls",Cases[tmp,{x:{_?NumericQ,_,_,__},y_?NumericQ,___}:>{x,y},\[Infinity]],
"txt",tmp=StringSplit[#,"\t"]&/@StringSplit[First[tmp],"\n"];Cases[tmp,{x_String,y_String/;StringMatchQ[StringReplace[y,","->""],NumberString],__}:>{DateList@x,stringToNumber@y},\[Infinity]]
]/.dateRules
];

SetAttributes[FRED, ReadProtected];


End[];

Protect[FRED];

EndPackage[]



